Start       EQU     0100H           ;Start all of our code on page 1
MemStart    EQU     1000H           ;RAM occupies 1000H to 1FFFH
MemTop      EQU     1FFFH
IntHigh     EQU     10H             ;High byte of interrupt vector (first page of RAM)

            ORG     0000H           ;Restart and boot address
            JP      START
    
            ORG     66H             ;NMI address
            JP      MemStart
    
            ORG     START
            LD      HL, MemStart    ;Load the start of RAM
            LD      DE, MemTop      ;Load the end of RAM
            LD      C,0FFH          ;First data to test- all ones
CopyData:   LD      (HL),C          ;Copy the data to RAM
            INC     HL              ;Point to next memory location
            LD      A,D             ;Compare high byte of counter to end of
                                    ;  memory.
            CP      H
            JR      NZ, CopyData
            LD      A,E             ;Compare low byte of counter to end of
                                    ;  memory.
            CP      L
            JR      NZ, CopyData
            LD      HL, MemStart    ;Load the start of RAM again
CheckData:  LD      A,(HL)          ;Copy byte from RAM to A
            CP      C               ;Compare it with the data
            JR      NZ, MemFailed
            INC     HL              ;Point to the next memory location
            LD      A,D             ;Compare high byte
            CP      H
            JR      NZ, CheckData
            LD      A,E             ;Compare low byte
            CP      H
            JR      NZ, CheckData
            LD      A,C             ;Copy data to A
            CP      0FFH            ;Compare with all ones
            JR      NZ, NotOnes
            LD      C,0AAH          ;Data was all ones, now check with data
                                    ;  = to 0AAH (10101010B)
            JR      CopyData
NotOnes:    CP      00H             ;Was last check with 0AAH or 00H
            JR      Z, MemPassed
            LD      C,00H           ;Last check was with 0AAH, now use 00H
            JR      CopyData
MemFailed:  HALT
MemPassed:  LD      SP, MemTop      ;Use the top of RAM as the SP
            LD      A, IntHigh      ;Load the high order byte of our interrupt
            LD      I,A
            IM      2               ;Set to Interrupt mode 2 (Vectored)
            EI                      ;Enable interrupts
            HALT                    ;Wait for interrupt
            END
            
