/* mac061997,98 by HNS/DSITRI hns@computer.org
** syscalls.h
**
** 02.01.1998	HNS		MKDIR, RMDIR added
*/

#pragma once

enum {
	EXIT=1,
    MOUNT,
    READ,
    WRITE,
    OPEN,
    ACCESS,
    UTIME,
    UNLINK,
    CLOSE,
    LAUNCH=10,
    GETUID,
    GETGID,
    GETPID,
    GETPPID,
    CHMOD,
    CHDIR,
    CHROOT,
    STAT,
    DUP,
    DUP2=20,
    LSEEK,
    SLEEP,
    SIGNAL,
    KILL,
    FSYNC,
    FSTAT,
    FCNTL,
    IOCTL,
    LINK,
    READDIR=30,
    SYNC,
    WAITPID,
    ACCEPT,
    BIND,
    CONNECT,
    GETPEERNAME,
    GETSOCKNAME,
    GETSOCKOPT,
    LISTEN,
    RECV=40,
    RECVFROM,
    SELECT,
    SEND,
    SENDTO,
    SETSOCKOPT,
    SHUTDOWN,
    SOCKET,
    PIPE,
    TIME,
    UNAME=50,
    TIMES,
    ALARM,
    PAUSE,
    PTRACE,
    MKDIR,
    RMDIR,
    CHOWN,
    UMASK,
    TCDRAIN,
    TCFLOW=60,
    TCFLUSH,
    TCSENDBREAK,
    TCGETATTR,
    TCSETATTR,
    TTYNAME,
    NICE,
    SYMLINK,
    READLINK,
	UMOUNT,
	GETTIMEOFDAY=70,
    /* nonstandard */
    GETARGV=100,	/* get pointers to original argv, envp */
    REALLOC,	/* allocate memory block */
    RESOLVEBYADDR,	/* DNS resolver */
    RESOLVEBYNAME,	/* DNS resolver */
    NUMSYSCALLS
    /* additional */
	};

struct __syscall
	{
	char psn[8];	/* process manager id data */
	long code;
	long arg1, arg2, arg3, arg4, arg5, arg6;
	};

struct __syscall_ret
	{ /* return block */
	long ret;	/* return value */
	long errno;	/* error number */
	};

struct __syscall_sig
	{ /* signal block */
	void (*sigfunc)(long);		/* signal handler to be called */
	long sig;	/* signal number */
	};

#define SIGNATURE		'HNmx'
#define SIGNATURE_CALL	'sysc'
#define SIGNATURE_RET	'sysr'
#define SIGNATURE_SIG	'sign'

/* EOF */