#ifdef __cplusplus
extern "C" {
#endif

/* The following 3 declarations are for use of the random-number
   generator rand and the associated functions randst and randgt for
   seed management.  This file (named rand.h) should be included in any
   program using these functions by executing
       #include "rand.h"
   before referencing the functions.
*/

extern double expon(double rmean,int istream);
/* return exponential random variable with mean rmean. */

extern float simrand(int stream);
/* Generate the next random number 0,1. */

extern void randst(long zset, int stream);
/* Set the current zrng for stream "stream" to zset. */

extern long randgt(int stream);
/* Return the current zrng for stream "stream". */

extern double uniform(double a,double b,int istream);
/* generate a u(a,b) random variable.  */

#ifdef __cplusplus
}
#endif

