/***
*
* usrdef.cc
*
* $Revision: 1.1 $
*
* Description:
*   Implementation of common useful functions.
*
* Author:
*   Juan Carlos Santamaria
*     E-mail: carlos@cc.gatech.edu
*     URL:    http://www.cc.gatech.edu/ai/students/jcs
*
* File name:
*   $Id: usrdef.cc,v 1.1 1996/08/28 18:45:06 carlos Exp $
*
* Revision History:
*   $Log: usrdef.cc,v $
*   Revision 1.1  1996/08/28  18:45:06  carlos
*   Initial revision
*
*
****/

#pragma  implementation


// -- Include files

#include <ctype.h>

#include "usrdef.h"


// -- Function definitions

istream& get_token( istream& from, char* token, int size )
{
    char c;
    for( ;; ) {
	      
	c = 0;
	if ( !(from >> c) ) {
	    token[0] = '\0';
	    break;
        }
        
        if ( c == ';' ) {                   
            while( from.get(c) && c!='\n' )    // skip comments
                ;
            continue;
        }
            
        if ( c=='\"' ) {
            from.get(token,size,'\"');
            if ( (from >> c) && c=='\"' )
                break;
            else {
	        from.clear( ios::badbit );
                token[0]='\0';
                break;
            }
        }

        token[0]=c;
        from.get(token+1,size-1,':');
        if ( (from >> c) && c==':' ) {
            break;
        }
        else {
            from.clear( ios::badbit );
            token[0]='\0';
            break;
        }
    }         

    return from;
}


double normalize_angle( double a, double reference )
{
    double tmp=fmod(a-reference, 2.0*M_PI );
    if (tmp>=0.0)
        return reference + tmp;
    else
        return 2.0*M_PI + reference + tmp;
}            


double normalize_angle_deg( double a, double reference )
{
    double tmp=fmod(a-reference, 360.0 );
    if (tmp>=0.0)
        return reference + tmp;
    else
        return 360.0 + reference + tmp;
}

     
