/***
*
* usrdef.h
*
* $Revision: 1.1 $
*
* Description:
*   Header file for common definitions for constants, types, and classes.
*
* Author:
*   Juan Carlos Santamaria
*     E-mail: carlos@cc.gatech.edu
*     URL:    http://www.cc.gatech.edu/ai/students/jcs
*
* File name:
*   $Id: usrdef.h,v 1.1 1996/08/28 18:45:04 carlos Exp $
*
* Revision History:
*   $Log: usrdef.h,v $
*   Revision 1.1  1996/08/28  18:45:04  carlos
*   Initial revision
*
*
****/

#pragma interface


#ifndef _INCL_USRDEF
#define _INCL_USRDEF


// -- Include files

#include <iostream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <bool.h>
#include <math.h>


// -- Constants definition

typedef unsigned char byte;

const double DEG2RAD = M_PI/180;
const double RAD2DEG = 180/M_PI;


// -- Class declarations


// -- Function prototypes

double normalize_angle( double a, double reference = -M_PI );


double normalize_angle_deg( double a, double reference = -180.0 );


inline void error( const char* str1, const char* str2 = "" )
{
    cerr << str1 << ' ' << str2 << '\n';
    exit(1);
}

istream& get_token( istream& from, char* token, int size );

#endif
